﻿using System.Drawing;

namespace PluralRichPresence.SimplyPlural
{
    public class Member
    {
        public string Name;
        public string Pronouns;
        public string? AvatarURL;
        public string Id;
        public string SystemId;

        public bool IsFronting
        {
            get
            {
                return FrontStartTime is not null;
            }
            set
            {
                FrontStartTime = 0;
            }
        }
        public ulong? FrontStartTime = null;

        public byte[]? DownloadAvatar()
        {
            if(this.AvatarURL is not null)
                return Rest.Download(this.AvatarURL).Result;
            return null;
        }

        public Member(string systemId, 
                      string name,
                      string pronouns,
                      string id,
                      string? avatarUUID,
                      string? avatarURL)
        {
            this.Name = name;
            this.Pronouns = pronouns;

            if ((avatarURL == "" || avatarURL is null) &&
                (avatarUUID != "" || avatarUUID is not null))
            {
                this.AvatarURL = "https://spaces.apparyllis.com/avatars/" + systemId + "/" + avatarUUID;
            }

            this.Id = id;
            this.SystemId = systemId;
        }
    }
}
